Subject: Re: the design of hpfsc

From: Zheng Gengbin <[email-masked]>
Date: Wed, 21 May 1997 09:00:22 +0800 (EAT)

On Tue, 20 May 1997, Guansong Zhang wrote:

> After supporting ghost area, our compiler has already been able to handle some
> simple real HPF program, and get better performance compared with PGI's
> compiler. The way it uses frontEnd system become more and more mature. But it
> also reveals the problem in our HPF parser: the implementation of hpfsc is not
> clear.
> 
> Originally, the hpfsc is to check sementics constrains when generating AST. And
> we can see it helps us find out many problems if we type in an HPF program
> without much thinking.
> 
> But it also has some responsibility to modify the AST a little. This makes the
> hpfsc as a part of the language parser. So hpfsc need to be used at each time
> to parse the compiler generated temporary .f file. And because the temporary
> file become longer and longer after each pass, the time caused by hpfsc gets
> longer.
> 
> Generating temporary .f (instead of .dep) file is valuble for us to debug each
> phase's problem and suitable in Xsageop lib for its poor memory management. We
> may have trans3, trans4, ... But is there necessary to check sementics
> constrains for each temporary file?
> 
> Please make comments on this.
> 

	In here , I also write a hpfc , which never generate the 
temporary .f files , or only generate the .f files for debug ( only for 
view ). The compiling stages should contain :

hpf2dep => hpfsc => trans2 => trans1 => trans0 => tof77

in stead of generating .f between stages and recompile the temporary .f ,
we use the .dep generated in the last stage directly as input . 
Sometimes this may have some problem , but I don't think it is because
of the poor memory management of Xsagelib , it ofen because we generate
a wrong node in AST .

	But if we do want to generate .f files for debug , I think one
of the most important content of debuging is just making semantic checking 
to the node program we generate , so if we do want to debug the whole 
phases , we have to pay some expense in hpfsc .

Gengbin

---

From: Zheng Gengbin <[email-masked]>
Date: Wed, 21 May 1997 22:11:48 +0800 (EAT)

> also reveals the problem in our HPF parser: the implementation of hpfsc is not

	Can you tell me which simple real HPF program can yield such high
performance ? Those samples in our testsuite ?

Zheng